## ocaml-expat 0.9.1+debian1

=== Makefile ===
#
#

# Change this to match your expat installation.
EXPAT_LIB=-lexpat
EXPAT_LIBDIR=/usr/local/lib
EXPAT_INCDIR=/usr/local/include

NAME=expat
OBJECTS=expat.cmo
XOBJECTS=$(OBJECTS:.cmo=.cmx)
C_OBJECTS=expat_stubs.o

ARCHIVE=$(NAME).cma
XARCHIVE=$(ARCHIVE:.cma=.cmxa)
CARCHIVE_NAME=mlexpat
CARCHIVE=lib$(CARCHIVE_NAME).a

# Flags for the C compiler.
CFLAGS=-DFULL_UNROLL -O2 -I$(EXPAT_INCDIR)

OCAMLC=ocamlc
OCAMLOPT=ocamlopt
OCAMLDEP=ocamldep
OCAMLMKLIB=ocamlmklib 
OCAMLDOC=ocamldoc
OCAMLFIND=ocamlfind

.PHONY: all
all: $(ARCHIVE)
.PHONY: allopt
allopt:  $(XARCHIVE)

depend: *.c *.ml *.mli
	gcc -MM *.c > depend	
	$(OCAMLDEP) *.mli *.ml >> depend

## Library creation
$(CARCHIVE): $(C_OBJECTS)
	$(OCAMLMKLIB) -oc $(CARCHIVE_NAME) $(C_OBJECTS) \
	-L$(EXPAT_LIBDIR) $(EXPAT_LIB)
$(ARCHIVE): $(CARCHIVE) $(OBJECTS)
	$(OCAMLMKLIB) -o $(NAME) $(OBJECTS) -oc $(CARCHIVE_NAME) \
	-L$(EXPAT_LIBDIR) $(EXPAT_LIB)
$(XARCHIVE): $(CARCHIVE) $(XOBJECTS)
	$(OCAMLMKLIB) -o $(NAME) $(XOBJECTS) -oc $(CARCHIVE_NAME) \
	-L$(EXPAT_LIBDIR) $(EXPAT_LIB)

## Installation
.PHONY: install
install: all
	{ test ! -f $(XARCHIVE) || extra="$(XARCHIVE) $(NAME).a"; }; \
	$(OCAMLFIND) install $(NAME) META $(NAME).cmi $(NAME).mli $(ARCHIVE) \
	dll$(CARCHIVE_NAME).so lib$(CARCHIVE_NAME).a $$extra

.PHONY: uninstall
uninstall:
	$(OCAMLFIND) remove $(NAME)

## Documentation
.PHONY: doc
doc: FORCE
	cd doc; $(OCAMLDOC) -html -I .. ../$(NAME).mli

## Testing
.PHONY: testall
testall: test testopt
.PHONY: test
test: unittest 	
	./unittest
.PHONY: testopt
testopt: unittest.opt
	./unittest.opt
unittest: all unittest.ml
	$(OCAMLFIND) ocamlc -o unittest -package oUnit -ccopt -L. -linkpkg \
	$(ARCHIVE) unittest.ml
unittest.opt: allopt unittest.ml
	$(OCAMLFIND) ocamlopt -o unittest.opt -package oUnit -ccopt -L. -linkpkg \
	$(XARCHIVE) unittest.ml

## Cleaning up
.PHONY: clean
clean::
	rm -f *~ *.cm* *.o *.a *.so doc/*.html doc/*.css depend \
	unittest unittest.opt

FORCE:

.SUFFIXES: .ml .mli .cmo .cmi .cmx

.mli.cmi:
	$(OCAMLC) -c $(COMPFLAGS) $<
.ml.cmo:
	$(OCAMLC) -c $(COMPLAGS) $<
.ml.cmx:
	$(OCAMLOPT) -c $(COMPFLAGS) $<
.c.o:
	$(OCAMLC) -c -ccopt "$(CFLAGS)" $<

include depend

## ocaml-expat 1.1.0

=== debian/changelog ===
ocaml-expat (1.1.0-1build2) jammy; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jan 2022 17:20:55 +0100

ocaml-expat (1.1.0-1build1) hirsute; urgency=medium

  * No-change rebuild for ocaml abi changes.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 02 Nov 2020 14:08:41 +0100

ocaml-expat (1.1.0-1) unstable; urgency=low

  [ Stéphane Glondu ]
  * Team upload
  * New upstream release
  * Update Vcs-* to point to salsa
  * Update Homepage and add debian/watch
  * Switch source package format to 3.0 (quilt)
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

  [ Ralf Treinen ]
  * Fixed typo in long description (closes: #651553)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 23 Aug 2020 14:51:38 +0200

ocaml-expat (0.9.1+debian1-7) unstable; urgency=low

  [ Stéphane Glondu ]
  * Fix CDBS include order (Closes: #569267)

  [ Enrico Tassi ]
  * Maintainer is now Debian OCaml Maintainers, I'm in Uploaders

 -- Enrico Tassi <gareuselesinge@debian.org>  Sun, 14 Feb 2010 15:52:28 +0100

ocaml-expat (0.9.1+debian1-6) unstable; urgency=low

  [ Stephane Glondu ]
  * Use ocaml.mk as a CDBS "rules" file (Closes: #549715)

  [ Enrico Tassi ]
  * Switch packaging to git
  * ported to new dh-ocaml
  * added debian/libexpat-ocaml-dev.ocamldoc
  * Section: ocaml
  * Fixed VCS-Browse field in control file
  * Bumped standards-version to 3.8.3, no changes
  * debian/compat set to 7, fixed build dependency accordingly
  * fixed copyright file adding years of copyright holding

 -- Enrico Tassi <gareuselesinge@debian.org>  Wed, 11 Nov 2009 17:33:24 +0100

ocaml-expat (0.9.1+debian1-5) unstable; urgency=low

  * Rebuild against 3.11
  * Updated standards-version to 3.8.0, no changes needed
  * Added dh-ocaml do build-depends
  * Adopted @OCamlStdlibDir@ and @OCamlStdlibDir@

 -- Enrico Tassi <gareuselesinge@debian.org>  Mon, 09 Mar 2009 22:27:20 +0100

ocaml-expat (0.9.1+debian1-4) unstable; urgency=low

  [ Stefano Zacchiroli ]
  * fix vcs-svn field to point just above the debian/ dir

  [ Enrico Tassi ]
  * rebuild agains ocaml 3.10.1
  * added Homepage control field
  * bumped standards version to 3.7.3

 -- Enrico Tassi <gareuselesinge@debian.org>  Sat, 09 Feb 2008 16:45:17 +0100

ocaml-expat (0.9.1+debian1-3) unstable; urgency=low

  * rebuilt against 3.10.0
  * moved rules to ocaml CDBS class
  * removed libexpat-ocaml-dev.docs since ocamldoc is now called by the CDBS
    class

 -- Enrico Tassi <gareuselesinge@debian.org>  Mon, 03 Sep 2007 15:29:06 +0100

ocaml-expat (0.9.1+debian1-1) unstable; urgency=low

  * Removed spurious directory from the orig.tgz (Closes: #379793)

 -- Enrico Tassi <gareuselesinge@debian.org>  Fri, 28 Jul 2006 10:22:57 +0200

ocaml-expat (0.9.1-5) unstable; urgency=low

  * rebuilt against ocaml 3.09.2

 -- Enrico Tassi <gareuselesinge@debian.org>  Thu, 18 May 2006 19:30:53 +0200

ocaml-expat (0.9.1-4) unstable; urgency=low

  * rebuilt against ocaml 3.09.1
  * added documentation (Closes: #310491)
  * maintainer email updated to gareuselesinge@debian.org

 -- Enrico Tassi <gareuselesinge@debian.org>  Sat, 14 Jan 2006 11:13:42 +0100

ocaml-expat (0.9.1-3) unstable; urgency=low

  * rebuilt against ocaml 3.09.0
  * moved debian/rules to cdbs
  * no more ocaml-version hardcoded inside any file. @OCamlABI@ is substituted
    in any FILE.in file (except control.in) at build time by the ocamlinit:
    rule producing the corresponding FILE in debian/.

 -- Enrico Tassi <gareuselesinge@users.sourceforge.net>  Sat, 26 Nov 2005 22:15:07 +0100

ocaml-expat (0.9.1-2) unstable; urgency=low

  * no more useless /usr/lib/ocaml/ocaml/3.08.3/stublibs is created
    (closes: Bug#303908)

 -- Enrico Tassi <gareuselesinge@users.sourceforge.net>  Sat,  9 Apr 2005 21:02:42 +0200

ocaml-expat (0.9.1-1) unstable; urgency=low

  * New upstream release
  * Rebuilt against ocaml 3.08.3

 -- Enrico Tassi <gareuselesinge@users.sourceforge.net>  Wed, 29 Mar 2005 11:32:27 +0100

ocaml-expat (0.9.0-1) unstable; urgency=low

  * Initial Release (Closes: Bug#291966).

 -- Enrico Tassi <gareuselesinge@users.sourceforge.net>  Sun, 23 Jan 2005 16:33:21 +0100

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

DESTDIR := $(CURDIR)/debian/tmp$(OCAML_STDLIB_DIR)

ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	DEB_MAKE_BUILD_TARGET = allopt NO_CUSTOM=y
else
	DEB_MAKE_BUILD_TARGET = all NO_CUSTOM=y
endif

%:
	dh $@ --with ocaml

override_dh_auto_build:
	$(MAKE) $(DEB_MAKE_BUILD_TARGET)

override_dh_auto_install:
	mkdir -p $(DESTDIR) $(CURDIR)/debian/tmp$(OCAML_DLL_DIR)
	OCAMLFIND_DESTDIR=$(DESTDIR) OCAMLFIND_LDCONF=ignore $(MAKE) install
	rm -f $(CURDIR)/debian/tmp$(OCAML_DLL_DIR)/*.owner

override_dh_auto_test:

=== debian/watch ===
version=3
opts="dversionmangle=s/\+debian[\.0-9]*$//" \
https://github.com/whitequark/ocaml-expat/releases .*/archive/v?([0-9.]+)\.tar\.gz

## ocaml-expat 1.3.0

=== Makefile ===
--- 
+++ 
@@ -9,30 +9,39 @@
 NAME=expat
 OBJECTS=expat.cmo
 XOBJECTS=$(OBJECTS:.cmo=.cmx)
-C_OBJECTS=expat_stubs.o
+C_OBJECTS=expat_stubs$(EXT_OBJ)
 
 ARCHIVE=$(NAME).cma
 XARCHIVE=$(ARCHIVE:.cma=.cmxa)
+XSARCHIVE=$(ARCHIVE:.cma=.cmxs)
 CARCHIVE_NAME=mlexpat
-CARCHIVE=lib$(CARCHIVE_NAME).a
+CARCHIVE=lib$(CARCHIVE_NAME)$(EXT_LIB)
 
 # Flags for the C compiler.
 CFLAGS=-DFULL_UNROLL -O2 -I$(EXPAT_INCDIR)
 
-OCAMLC=ocamlc
-OCAMLOPT=ocamlopt
-OCAMLDEP=ocamldep
-OCAMLMKLIB=ocamlmklib 
-OCAMLDOC=ocamldoc
 OCAMLFIND=ocamlfind
+OCAMLPKGS=-package bytes
+OCAMLC=$(OCAMLFIND) ocamlc $(OCAMLPKGS)
+OCAMLOPT=$(OCAMLFIND) ocamlopt $(OCAMLPKGS)
+OCAMLDEP=$(OCAMLFIND) ocamldep $(OCAMLPKGS)
+OCAMLMKLIB=$(OCAMLFIND) ocamlmklib $(OCAMLPKGS)
+OCAMLDOC=$(OCAMLFIND) ocamldoc $(OCAMLPKGS)
+OCAMLDIR=$(shell $(OCAMLFIND) query stdlib)
+include $(OCAMLDIR)/Makefile.config
 
+OPT_TARGETS=	$(XARCHIVE)
+ifeq ($(SUPPORTS_SHARED_LIBRARIES),true)
+OPT_TARGETS+=	$(XSARCHIVE)
+endif
+ 
 .PHONY: all
 all: $(ARCHIVE)
 .PHONY: allopt
-allopt:  $(XARCHIVE)
+allopt:  $(OPT_TARGETS)
 
 depend: *.c *.ml *.mli
-	gcc -MM *.c > depend	
+	gcc -I $(OCAMLDIR) -MM *.c > depend
 	$(OCAMLDEP) *.mli *.ml >> depend
 
 ## Library creation
@@ -45,13 +54,17 @@
 $(XARCHIVE): $(CARCHIVE) $(XOBJECTS)
 	$(OCAMLMKLIB) -o $(NAME) $(XOBJECTS) -oc $(CARCHIVE_NAME) \
 	-L$(EXPAT_LIBDIR) $(EXPAT_LIB)
+$(XSARCHIVE): $(CARCHIVE) $(XOBJECTS)
+	$(OCAMLOPT) -linkall -shared -o $(XSARCHIVE) $(XOBJECTS) $(CARCHIVE) \
+	-ccopt -L$(EXPAT_LIBDIR) -cclib $(EXPAT_LIB)
 
 ## Installation
 .PHONY: install
 install: all
-	{ test ! -f $(XARCHIVE) || extra="$(XARCHIVE) $(NAME).a"; }; \
+	{ test ! -f $(XARCHIVE) || extra="$(OPT_TARGETS) $(NAME)$(EXT_LIB)"; }; \
 	$(OCAMLFIND) install $(NAME) META $(NAME).cmi $(NAME).mli $(ARCHIVE) \
-	dll$(CARCHIVE_NAME).so lib$(CARCHIVE_NAME).a $$extra
+	lib$(CARCHIVE_NAME)$(EXT_LIB) $$extra \
+	-optional dll$(CARCHIVE_NAME)$(EXT_DLL)
 
 .PHONY: uninstall
 uninstall:
@@ -66,8 +79,8 @@
 .PHONY: testall
 testall: test testopt
 .PHONY: test
-test: unittest 	
-	./unittest
+test: unittest
+	CAML_LD_LIBRARY_PATH=$(pwd) ./unittest
 .PHONY: testopt
 testopt: unittest.opt
 	./unittest.opt
@@ -81,8 +94,8 @@
 ## Cleaning up
 .PHONY: clean
 clean::
-	rm -f *~ *.cm* *.o *.a *.so doc/*.html doc/*.css depend \
-	unittest unittest.opt
+	rm -f *~ *.cm* *$(EXT_OBJ) *$(EXT_LIB) *$(EXT_DLL) doc/*.html doc/*.css depend \
+	unittest unittest.opt oUnit*.cache
 
 FORCE:
 
@@ -98,6 +111,3 @@
 	$(OCAMLC) -c -ccopt "$(CFLAGS)" $<
 
 include depend
-
-
-

=== debian/changelog ===
ocaml-expat (1.3.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 30 Sep 2023 21:15:24 +0200

ocaml-expat (1.1.0-2) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * Bump Standards-Version to 4.6.2

  [ Ralf Treinen ]
  * fix debian/watch

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository-Browse.
  * Fix day-of-week for changelog entry 0.9.1-1.
  * Remove MIA uploaders (Closes: #995556)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 02 Sep 2023 07:57:20 +0200

=== debian/control ===
Source: ocaml-expat
Priority: optional
Section: ocaml
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libexpat1-dev,
 ocaml,
 ocaml-findlib,
 dh-ocaml
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-expat.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-expat
Homepage: https://github.com/whitequark/ocaml-expat

Package: libexpat-ocaml-dev
Architecture: any
Depends: libexpat1-dev, ocaml-findlib, ${misc:Depends}, ${shlibs:Depends}, ${ocaml:Depends}
Provides: ${ocaml:Provides}
Description: OCaml expat bindings (development)
 This Objective Caml library provides XML parsing facilities based on the expat
 library.
 .
 This package contains the development part of the OCaml expat package.

Package: libexpat-ocaml
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${ocaml:Depends}
Provides: ${ocaml:Provides}
Breaks: libexpat-ocaml-dev (<< 1.1.0)
Replaces: libexpat-ocaml-dev (<< 1.1.0)
Description: OCaml expat bindings (runtime)
 This Objective Caml library provides XML parsing facilities based on the expat
 library.
 .
 This package contains only the shared runtime stub libraries.

=== debian/watch ===
version=3
opts="dversionmangle=s/\+debian[\.0-9]*$//" \
https://github.com/whitequark/ocaml-expat/tags .*/tags/v?([0-9.]+)\.tar\.gz
